(function() {
  var delay, jqueryify;
  var __slice = Array.prototype.slice;

  delay = function(job) {
    var _ref;
    if (this._jquery != null) {
      return job();
    } else {
      if ((_ref = this._jquery_delay) == null) this._jquery_delay = [];
      return this._jquery_delay.push(job);
    }
  };

  jqueryify = function(tpl) {
    var old_query;
    tpl.xml._jquery = $();
    tpl.on('close', function(el) {
      var job, _i, _len, _ref;
      el._jquery = $(el.toString());
      if (el._jquery_delay != null) {
        _ref = el._jquery_delay;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          job = _ref[_i];
          job();
        }
        delete el._jquery_delay;
      }
      delay.call(el.parent, function() {
        if (el.parent === tpl.xml) {
          return el.parent._jquery = el.parent._jquery.add(el._jquery);
        } else {
          return el.parent._jquery.append(el._jquery);
        }
      });
      return el.on('newListener', function(type) {
        var _ref2, _ref3;
        if ((_ref2 = el._events) != null ? (_ref3 = _ref2[type]) != null ? _ref3.length : void 0 : void 0) {
          return;
        }
        return el._jquery.bind(type, function() {
          el.emit.apply(el, [type, this].concat(__slice.call(arguments)));
        });
      });
    });
    tpl.on('text', function(el, text) {
      return delay.call(el, function() {
        return el._jquery.text(text);
      });
    });
    tpl.on('raw', function(el, html) {
      return delay.call(el, function() {
        return el._jquery.html(html);
      });
    });
    tpl.on('attach', function(el) {
      var _ref;
      return (_ref = el._jquery) != null ? _ref.appendTo(el.parent._jquery) : void 0;
    });
    tpl.on('detach', function(el) {
      var _ref;
      return (_ref = el._jquery) != null ? _ref.detach() : void 0;
    });
    tpl.on('attr', function(el, key, value) {
      return delay.call(el, function() {
        return el._jquery.attr(key, value);
      });
    });
    tpl.on('attr:remove', function(el, key) {
      return delay.call(el, function() {
        return el._jquery.removeAttr(key);
      });
    });
    tpl.on('remove', function(el) {
      var _ref;
      return (_ref = el._jquery) != null ? _ref.remove() : void 0;
    });
    tpl.on('end', function() {
      return tpl.jquery = tpl.xml._jquery;
    });
    old_query = tpl.xml.query;
    tpl.xml.query = function(type, tag, key) {
      if (tag._jquery == null) return old_query.call(this, type, tag, key);
      if (type === 'attr') {
        return tag._jquery.attr(key);
      } else if (type === 'text') {
        return tag._jquery.text();
      }
    };
    return tpl;
  };

  module.exports = jqueryify;

  if (process.title === 'browser') {
    (function() {
      if (this.dynamictemplate != null) {
        return this.dynamictemplate.jqueryify = jqueryify;
      } else {
        return this.dynamictemplate = {
          jqueryify: jqueryify
        };
      }
    }).call(window);
  }

}).call(this);
